/*
  E097BUARTI

  DXMIO𑕒ĎgpI/O{[h̓oɔAUSART؂ւKv
  ̂ŁAgp@\}NŐ؂ւ悤Ɏd|B

  EgpUSARTUSART0USART32ށA֐̓|[O/荞/DMA3ނ
    USART_TYPE}Nɒ`ꂽlőI
  EGPIOUSART0̏ꍇTTL/RS-485 I/FɐڑĂ[qAUSART3̏ꍇP07/P08Œ
*/

#ifndef INC_E097B_USART_H
#define INC_E097B_USART_H

#ifdef __cplusplus
extern "C" {
#endif

#include  <us.h>

#define _TXD2   (7)   // P0_7 (CN1-7)
#define _RXD2   (6)   // P0_6 (CN1-6)

// USART3̒ǉ
#define us3_gpio_init() \
  static const TPin usart3_pins[] = {{ _TXD2, PIO_TYPE_MOVABLE, SWM_U3_TXD_O, PIO_MODE_DEFAULT }, { _RXD2, PIO_TYPE_MOVABLE, SWM_U3_RXD_I, PIO_MODE_PULLUP },}; \
  PIO_Configure (usart3_pins, PIO_LISTSIZE (usart3_pins)); \
  LPC_SYSCON->UART3CLKSEL = SYSCON_FLEXCOMMCLKSELSRC_FRG0; \

// CN3/CN4 d|[O
#if USART_TYPE == 1
#define us_init(a,b,c,d,e,f,g)     usart0_init(a,b,c,d,e,f,g)             // 
#define us_setbaudrate usart0_setbaudrate   // {[[gύX
#define us_tx_buff  usart0_tx_buff          // c著MoCg
#define us_rx_buff  usart0_rx_buff          // Mf[^̖ooCg
#define us_tx_purge usart0_tx_purge         // Mf[^|
#define us_rx_purge usart0_rx_purge         // Mf[^|
#define us_putc     usart0_putc             // 1oCgM
#define us_puts     usart0_puts             // 񑗐M
#define us_putsb    usart0_putsb            // oCg񑗐M
#define us_getc     usart0_getc             // 1oCgM҂
#define us_gets     usart0_gets             // M҂
#define us_printf   usart0_printf           // 񑗐M
#define us_scanf    usart0_scanf            // M
// CN3/CN4 d荞ݔ
#elif USART_TYPE == 2
#define us_init(a,b,c,d,e,f,g)     usart0_int_init(a,b,c,d,e,f,g)
#define us_setbaudrate usart0_int_setbaudrate
#define us_tx_buff  usart0_int_tx_buff
#define us_rx_buff  usart0_int_rx_buff
#define us_tx_purge usart0_int_tx_purge
#define us_rx_purge usart0_int_rx_purge
#define us_putc     usart0_int_putc
#define us_puts     usart0_int_puts
#define us_putsb    usart0_int_putsb
#define us_getc     usart0_int_getc
#define us_gets     usart0_int_gets
#define us_printf   usart0_int_printf
#define us_scanf    usart0_int_scanf
// CN3/CN4 dDMA
#elif USART_TYPE == 3
#define us_init(a,b,c,d,e,f,g)     usart0_dma_init(a,b,c,d,e,f,g)
#define us_setbaudrate usart0_dma_setbaudrate
#define us_tx_buff  usart0_dma_tx_buff
#define us_rx_buff  usart0_dma_rx_buff
#define us_tx_purge usart0_dma_tx_purge
#define us_rx_purge usart0_dma_rx_purge
#define us_putc     usart0_dma_putc
#define us_puts     usart0_dma_puts
#define us_putsb    usart0_dma_putsb
#define us_getc     usart0_dma_getc
#define us_gets     usart0_dma_gets
#define us_printf   usart0_dma_printf
#define us_scanf    usart0_dma_scanf
// CN1 Sd|[O
#elif USART_TYPE == 4
#define us_init(a,b,c,d,e,f,g)     { us3_gpio_init(); usart3_init(a,b,c,d,e,f,g); }
#define us_setbaudrate usart3_setbaudrate
#define us_tx_buff  usart3_tx_buff
#define us_rx_buff  usart3_rx_buff
#define us_tx_purge usart3_tx_purge
#define us_rx_purge usart3_rx_purge
#define us_putc     usart3_putc
#define us_puts     usart3_puts
#define us_putsb    usart3_putsb
#define us_getc     usart3_getc
#define us_gets     usart3_gets
#define us_printf   usart3_printf
#define us_scanf    usart3_scanf
// CN1 Sd荞ݔ
#elif USART_TYPE == 5
#define us_init(a,b,c,d,e,f,g)     { us3_gpio_init(); usart3_int_init(a,b,c,d,e,f,g); }
#define us_setbaudrate usart3_int_setbaudrate
#define us_tx_buff  usart3_int_tx_buff
#define us_rx_buff  usart3_int_rx_buff
#define us_tx_purge usart3_int_tx_purge
#define us_rx_purge usart3_int_rx_purge
#define us_putc     usart3_int_putc
#define us_puts     usart3_int_puts
#define us_putsb    usart3_int_putsb
#define us_getc     usart3_int_getc
#define us_gets     usart3_int_gets
#define us_printf   usart3_int_printf
#define us_scanf    usart3_int_scanf
// CN1 SdDMA
#elif USART_TYPE == 6
#define us_init(a,b,c,d,e,f,g)     { us3_gpio_init(); usart3_dma_init(a,b,c,d,e,f,g); }
#define us_setbaudrate usart3_dma_setbaudrate
#define us_tx_buff  usart3_dma_tx_buff
#define us_rx_buff  usart3_dma_rx_buff
#define us_tx_purge usart3_dma_tx_purge
#define us_rx_purge usart3_dma_rx_purge
#define us_putc     usart3_dma_putc
#define us_puts     usart3_dma_puts
#define us_putsb    usart3_dma_putsb
#define us_getc     usart3_dma_getc
#define us_gets     usart3_dma_gets
#define us_printf   usart3_dma_printf
#define us_scanf    usart3_dma_scanf
#else
#error "USART_TYPE macro is not defined or the value is out of range."
#endif


#ifdef __cplusplus
}
#endif

#endif
